package net.wanji.com.service;

import lombok.NonNull;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import net.wanji.com.mapper.TCrossInfoMapper;
import net.wanji.com.mapper.ManufacturerInfoMapper;
import net.wanji.com.pojo.po.CrossInfoPO;
import net.wanji.com.pojo.po.ManufacturerInfoPO;
import org.springframework.stereotype.Service;

/**
 * @author duanruiming
 * @date 2023/05/08 16:12
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class CommonService {

    private final TCrossInfoMapper TCrossInfoMapper;
    private final ManufacturerInfoMapper manufacturerInfoMapper;

    /**
     * 通过路口编号获取厂商编码
     *
     * @param crossId
     * @return
     */
    @NonNull
    public String getManufacturerCodeByCrossId(String crossId) {
        CrossInfoPO crossInfoPO = TCrossInfoMapper.selectByPrimaryKey(crossId);
        Integer manufacturerId = crossInfoPO.getManufacturerId();
        ManufacturerInfoPO manufacturerInfoPO = manufacturerInfoMapper.selectById(manufacturerId);
        return manufacturerInfoPO.getCode();
    }
}
